package de.jatitv.opsecurity.listener.opWhitelist;

import de.jatitv.opsecurity.Util;
import de.jatitv.opsecurity.config.languages.SelectMessages;
import de.jatitv.opsecurity.config.config.SelectConfig;
import de.jatitv.opsecurity.system.BungeeSend;
import de.jatitv.opsecurity.system.Main;
import de.jatitv.opsecurity.system.Permissions;
import net.t2code.lib.Spigot.Lib.commands.Cmd;
import net.t2code.lib.Spigot.Lib.messages.send;
import net.t2code.lib.Spigot.Lib.replace.Replace;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;

public class Check {
    public static Boolean onCheck(Player player, Boolean join) {
        if (!SelectConfig.opWhitelistEnable)  return false;
        if (!player.isOp()) return false;
        if (checkOpWhitelist(player)) return false;
        if (join) {
            send.console(Replace.replace(Util.getPrefix(),SelectMessages.opConsoleOnJoin.replace("[player]", player.getName())));
        }
        if (SelectConfig.notifyWarn) {

        }





    }
    private static void notify(Player player, Boolean join){
        if (SelectConfig.bungee){
            BungeeSend.notify(player,join);
            return;
        }

        for (Player target : Bukkit.getOnlinePlayers()) {
            if (target.hasPermission(Permissions.notify)) {
                send.player(target,SelectMessages.opConsoleOnJoin.replace("[player]", player.getName()));




                if (join) {
                    target.sendMessage(Replace.replace(Util.getPrefix(),SelectMessages.opConsoleOnJoin.replace("[player]", player.getName())));
                } else target.sendMessage(Replace.replace(Util.getPrefix(),SelectMessages.OP_consoleKick.replace("[player]", player.getName())));
                if (SelectConfig.notifySoundEnable) {
                    target.playSound(player.getLocation(), SelectConfig.notifySound, 3, 1);
                }
            }
        }
    }


    private static void kickCMD(Player player, String cmd) {
        if (cmd.contains("bungee:")) {
            //todo
            return;
        }
        Cmd.console(cmd.replace("[player]", player.getName()));
    }

    private static Boolean checkOpWhitelist(Player player) {
        if (Main.opHashMap.containsKey(player.getName().toLowerCase())) {
            if (Main.opHashMap.get(player.getName().toLowerCase()).UUID.equals(player.getUniqueId().toString().replace("-", ""))) {
                return true;
            } else {
                send.console(SelectMessages.ExactReason.replace("[reason]", "Player UUID: " + player.getUniqueId().toString() + " not whitelisted"));
                return false;
            }
        } else {
            send.console(SelectMessages.ExactReason.replace("[reason]", "Player name: " + player.getName() + " not whitelisted"));
            return false;
        }
    }
}
