// This claas was created by JaTiTV

package de.jatitv.opsecurity.config.config;

import de.jatitv.opsecurity.system.Main;
import net.t2code.lib.Spigot.Lib.minecraftVersion.MCVersion;
import org.bukkit.Bukkit;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;
import java.util.Arrays;
import java.util.List;

public class CreateConfig {

    private static String Prefix = "§8[§2OP§4Security§8] ";

    public static void configCreate() {
        Bukkit.getConsoleSender().sendMessage(Prefix + "§4config.yml load...");

        File configYML = new File(Main.plugin.getDataFolder().getPath(), "config.yml");
        YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(configYML);

        yamlConfiguration.set("ConfigVersion", 3);

        set("Plugin.UpdateCheckOnJoin", true, yamlConfiguration);
        set("Plugin.language", "english", yamlConfiguration);
        set("Plugin.OnlyOPcanUseThePlugin", true, yamlConfiguration);
        set("Plugin.Bungee", false, yamlConfiguration);

        set("Check.OnJoin", true, yamlConfiguration);
        set("Check.OnInteract", true, yamlConfiguration);
        set("Check.OnCommand", true, yamlConfiguration);
        set("Check.OnChat", true, yamlConfiguration);
        set("Check.Timer.Enable", true, yamlConfiguration);
        set("Check.Timer.RefreshTime_inSec", 60, yamlConfiguration);

        set("Kick.Command", "minecraft:kick [player] [reason]", yamlConfiguration);
        set("Notify.JoinWarn.Enable", true, yamlConfiguration);
        set("Notify.Sound.Enable", true, yamlConfiguration);

        if (MCVersion.minecraft1_8) {
            set("Notify.Sound.Sound", "NOTE_PIANO", yamlConfiguration);
        } else if (MCVersion.minecraft1_9 || MCVersion.minecraft1_10 || MCVersion.minecraft1_11 || MCVersion.minecraft1_12) {
            set("Notify.Sound.Sound", "BLOCK_NOTE_HARP", yamlConfiguration);
        } else set("Notify.Sound.Sound", "BLOCK_NOTE_BLOCK_HARP", yamlConfiguration);

        set("OP_Whitelist.Enable", false, yamlConfiguration);
        set("OP_Whitelist.PlayerMustBeOnlineToOp", true, yamlConfiguration);
        if (yamlConfiguration.get("OP_Whitelist.Whitelist") == null) {
            set("OP_Whitelist.Whitelist." + "player1" + ".UUID", "00000000-0000-0000-0000-000000000000", yamlConfiguration);
            set("OP_Whitelist.Whitelist." + "player2" + ".UUID", "00000000-0000-0000-0000-000000000000", yamlConfiguration);
        }

        set("OP_Whitelist.noOpPlayerDeop.Enable", true, yamlConfiguration);
        set("OP_Whitelist.noOpPlayerDeop.PlayerSendMessage", true, yamlConfiguration);
        set("OP_Whitelist.noOpPlayerKick.Enable", true, yamlConfiguration);
        set("OP_Whitelist.customCommands.Enable", false, yamlConfiguration);
        set("OP_Whitelist.customCommands.Commands", Arrays.asList("kick [player] &4You have op but are not authorized to do so, that's why you were kicked!"), yamlConfiguration);

        set("Permission_Whitelist.Enable", false, yamlConfiguration);
        set("Permission_Whitelist.Permissions", Arrays.asList("*", "opsecurity.admin"), yamlConfiguration);

        if (yamlConfiguration.get("Permission_Whitelist.Whitelist") == null) {
            set("Permission_Whitelist.Whitelist." + "player1" + ".UUID", "00000000-0000-0000-0000-000000000000", yamlConfiguration);
            set("Permission_Whitelist.Whitelist." + "player2" + ".UUID", "00000000-0000-0000-0000-000000000000", yamlConfiguration);
        }

        set("Permission_Whitelist.PlayerWhithPermission_kick", true, yamlConfiguration);
        set("Permission_Whitelist.customCommands.Enable", false, yamlConfiguration);
        set("Permission_Whitelist.customCommands.Commands", Arrays.asList("lp user [player] permission unset *", "lp user [player] permission unset opsecurity.admin"), yamlConfiguration);

        //set("LuckPerms_Whitelist.Enable", LP_Enable, yamlConfiguration);
        //set("LuckPerms_Whitelist.AllowFromConsole", LP_AllowFromConsole, yamlConfiguration);

        //set("LuckPerms_Whitelist.Whitelist", LP_Whitelist, yamlConfiguration);

        try {
            yamlConfiguration.save(configYML);
        } catch (IOException e) {
            e.printStackTrace();
        }
        Bukkit.getConsoleSender().sendMessage(Prefix + "§2Config.yml loaded successfully.");
    }

    private static void set(String path, String value, YamlConfiguration config) {
        if (!config.contains(path)) {
            config.set(path, value);
        }
    }

    private static void set(String path, Integer value, YamlConfiguration config) {
        if (!config.contains(path)) {
            config.set(path, value);
        }
    }

    private static void set(String path, Double value, YamlConfiguration config) {
        if (!config.contains(path)) {
            config.set(path, value);
        }
    }

    private static void set(String path, Boolean value, YamlConfiguration config) {
        if (!config.contains(path)) {
            config.set(path, value);
        }
    }

    private static void set(String path, List value, YamlConfiguration config) {
        if (!config.contains(path)) {
            config.set(path, value);
        }
    }
}
